package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.CaseVerifyBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class CaseVerifyModelImpl implements ICaseVerifyModel {

    private OnGetCaseVerifyListener listener;

    public CaseVerifyModelImpl(OnGetCaseVerifyListener caseCheckListener) {
        this.listener = caseCheckListener;
    }

    public interface OnGetCaseVerifyListener {
        void onSuccess(CaseVerifyBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(int limit, int offset) {
        Observable<CaseVerifyBean> observable = RetrofitServiceManager.getCaseVerifyListResult(limit, offset);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<CaseVerifyBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(CaseVerifyBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
